/* ide-vala-locator.c generated by valac 0.46.2, the Vala compiler
 * generated from ide-vala-locator.vala, do not modify */

/*
 * Copyright 2008 Abderrahim Kitouni
 * Copyright 2015 Christian Hergert <christian@hergert.me>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Finds the innermost block containing the given location */

#include <vala.h>
#include <glib-object.h>
#include <glib.h>
#include <valagee.h>
#include <string.h>

#define IDE_TYPE_VALA_LOCATOR (ide_vala_locator_get_type ())
#define IDE_VALA_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IDE_TYPE_VALA_LOCATOR, IdeValaLocator))
#define IDE_VALA_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IDE_TYPE_VALA_LOCATOR, IdeValaLocatorClass))
#define IDE_IS_VALA_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IDE_TYPE_VALA_LOCATOR))
#define IDE_IS_VALA_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IDE_TYPE_VALA_LOCATOR))
#define IDE_VALA_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IDE_TYPE_VALA_LOCATOR, IdeValaLocatorClass))

typedef struct _IdeValaLocator IdeValaLocator;
typedef struct _IdeValaLocatorClass IdeValaLocatorClass;
typedef struct _IdeValaLocatorPrivate IdeValaLocatorPrivate;

#define IDE_VALA_LOCATOR_TYPE_LOCATION (ide_vala_locator_location_get_type ())
typedef struct _IdeValaLocatorLocation IdeValaLocatorLocation;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _IdeValaLocator {
	ValaCodeVisitor parent_instance;
	IdeValaLocatorPrivate * priv;
};

struct _IdeValaLocatorClass {
	ValaCodeVisitorClass parent_class;
};

struct _IdeValaLocatorLocation {
	guint line;
	guint column;
};

struct _IdeValaLocatorPrivate {
	IdeValaLocatorLocation location;
	ValaCodeNode* innermost;
};

static gint IdeValaLocator_private_offset;
static gpointer ide_vala_locator_parent_class = NULL;

GType ide_vala_locator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IdeValaLocator, vala_code_visitor_unref)
static GType ide_vala_locator_location_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static IdeValaLocatorLocation* ide_vala_locator_location_dup (const IdeValaLocatorLocation* self);
static void ide_vala_locator_location_free (IdeValaLocatorLocation* self);
ValaCodeNode* ide_vala_locator_locate (IdeValaLocator* self,
                                       ValaSourceFile* file,
                                       guint line,
                                       guint column);
static void ide_vala_locator_location_init (IdeValaLocatorLocation *self,
                                     guint line,
                                     guint column);
static gboolean ide_vala_locator_is_closer_to_location (IdeValaLocator* self,
                                                 ValaCodeNode* node);
static gboolean ide_vala_locator_update_location (IdeValaLocator* self,
                                           ValaCodeNode* node,
                                           gboolean assign);
static gboolean ide_vala_locator_location_inside (IdeValaLocatorLocation *self,
                                           ValaCodeNode* node);
static void ide_vala_locator_real_visit_assignment (ValaCodeVisitor* base,
                                             ValaAssignment* a);
static void ide_vala_locator_real_visit_block (ValaCodeVisitor* base,
                                        ValaBlock* b);
static void ide_vala_locator_real_visit_namespace (ValaCodeVisitor* base,
                                            ValaNamespace* ns);
static void ide_vala_locator_real_visit_class (ValaCodeVisitor* base,
                                        ValaClass* cl);
static void ide_vala_locator_real_visit_data_type (ValaCodeVisitor* base,
                                            ValaDataType* type);
static void ide_vala_locator_real_visit_struct (ValaCodeVisitor* base,
                                         ValaStruct* st);
static void ide_vala_locator_real_visit_interface (ValaCodeVisitor* base,
                                            ValaInterface* iface);
static void ide_vala_locator_real_visit_method (ValaCodeVisitor* base,
                                         ValaMethod* m);
static void ide_vala_locator_real_visit_method_call (ValaCodeVisitor* base,
                                              ValaMethodCall* expr);
static void ide_vala_locator_real_visit_member_access (ValaCodeVisitor* base,
                                                ValaMemberAccess* expr);
static void ide_vala_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                                  ValaCreationMethod* m);
static void ide_vala_locator_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                             ValaObjectCreationExpression* expr);
static void ide_vala_locator_real_visit_property (ValaCodeVisitor* base,
                                           ValaProperty* prop);
static void ide_vala_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                                    ValaPropertyAccessor* acc);
static void ide_vala_locator_real_visit_constructor (ValaCodeVisitor* base,
                                              ValaConstructor* c);
static void ide_vala_locator_real_visit_destructor (ValaCodeVisitor* base,
                                             ValaDestructor* d);
static void ide_vala_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                               ValaIfStatement* stmt);
static void ide_vala_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                                   ValaSwitchStatement* stmt);
static void ide_vala_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                                 ValaSwitchSection* section);
static void ide_vala_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                                  ValaWhileStatement* stmt);
static void ide_vala_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                               ValaDoStatement* stmt);
static void ide_vala_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                                ValaForStatement* stmt);
static void ide_vala_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                    ValaForeachStatement* stmt);
static void ide_vala_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                                ValaTryStatement* stmt);
static void ide_vala_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                               ValaCatchClause* clause);
static void ide_vala_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                                 ValaLockStatement* stmt);
static void ide_vala_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                       ValaExpressionStatement* stmt);
static void ide_vala_locator_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                        ValaDeclarationStatement* stmt);
static void ide_vala_locator_real_visit_local_variable (ValaCodeVisitor* base,
                                                 ValaLocalVariable* variable);
static void ide_vala_locator_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                      ValaExpression* expr);
static void ide_vala_locator_real_visit_expression (ValaCodeVisitor* base,
                                             ValaExpression* expr);
IdeValaLocator* ide_vala_locator_new (void);
IdeValaLocator* ide_vala_locator_construct (GType object_type);
static void ide_vala_locator_finalize (ValaCodeVisitor * obj);

static inline gpointer
ide_vala_locator_get_instance_private (IdeValaLocator* self)
{
	return G_STRUCT_MEMBER_P (self, IdeValaLocator_private_offset);
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

ValaCodeNode*
ide_vala_locator_locate (IdeValaLocator* self,
                         ValaSourceFile* file,
                         guint line,
                         guint column)
{
	ValaCodeNode* _tmp0_;
	ValaCodeNode* _tmp1_;
	ValaCodeNode* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_critical ("ide-vala-locator.vala:58: ~~ START ~~");
	ide_vala_locator_location_init (&self->priv->location, line, column);
	_vala_code_node_unref0 (self->priv->innermost);
	self->priv->innermost = NULL;
	vala_source_file_accept_children (file, (ValaCodeVisitor*) self);
	_tmp0_ = self->priv->innermost;
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
ide_vala_locator_is_closer_to_location (IdeValaLocator* self,
                                        ValaCodeNode* node)
{
	ValaCodeNode* _tmp0_;
	ValaCodeNode* _tmp1_;
	ValaSourceReference* node_src = NULL;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceReference* innermost_src = NULL;
	ValaCodeNode* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaSourceReference* _tmp6_;
	gboolean _tmp7_ = FALSE;
	ValaSourceReference* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaSourceLocation _tmp12_ = {0};
	ValaSourceLocation _tmp13_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = self->priv->innermost;
	if (_tmp0_ == NULL) {
		result = TRUE;
		return result;
	}
	_tmp1_ = self->priv->innermost;
	if (_tmp1_ == node) {
		result = FALSE;
		return result;
	}
	_tmp2_ = vala_code_node_get_source_reference (node);
	_tmp3_ = _tmp2_;
	node_src = _tmp3_;
	_tmp4_ = self->priv->innermost;
	_tmp5_ = vala_code_node_get_source_reference (_tmp4_);
	_tmp6_ = _tmp5_;
	innermost_src = _tmp6_;
	_tmp8_ = node_src;
	vala_source_reference_get_begin (_tmp8_, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = innermost_src;
	vala_source_reference_get_begin (_tmp11_, &_tmp12_);
	_tmp13_ = _tmp12_;
	if (_tmp10_.line > _tmp13_.line) {
		_tmp7_ = TRUE;
	} else {
		ValaSourceReference* _tmp14_;
		ValaSourceLocation _tmp15_ = {0};
		ValaSourceLocation _tmp16_;
		ValaSourceReference* _tmp17_;
		ValaSourceLocation _tmp18_ = {0};
		ValaSourceLocation _tmp19_;
		_tmp14_ = node_src;
		vala_source_reference_get_end (_tmp14_, &_tmp15_);
		_tmp16_ = _tmp15_;
		_tmp17_ = innermost_src;
		vala_source_reference_get_end (_tmp17_, &_tmp18_);
		_tmp19_ = _tmp18_;
		_tmp7_ = _tmp16_.line < _tmp19_.line;
	}
	if (_tmp7_) {
		result = TRUE;
		return result;
	} else {
		gboolean _tmp20_ = FALSE;
		ValaSourceReference* _tmp21_;
		ValaSourceLocation _tmp22_ = {0};
		ValaSourceLocation _tmp23_;
		ValaSourceReference* _tmp24_;
		ValaSourceLocation _tmp25_ = {0};
		ValaSourceLocation _tmp26_;
		_tmp21_ = node_src;
		vala_source_reference_get_begin (_tmp21_, &_tmp22_);
		_tmp23_ = _tmp22_;
		_tmp24_ = innermost_src;
		vala_source_reference_get_begin (_tmp24_, &_tmp25_);
		_tmp26_ = _tmp25_;
		if (_tmp23_.line == _tmp26_.line) {
			ValaSourceReference* _tmp27_;
			ValaSourceLocation _tmp28_ = {0};
			ValaSourceLocation _tmp29_;
			ValaSourceReference* _tmp30_;
			ValaSourceLocation _tmp31_ = {0};
			ValaSourceLocation _tmp32_;
			_tmp27_ = node_src;
			vala_source_reference_get_begin (_tmp27_, &_tmp28_);
			_tmp29_ = _tmp28_;
			_tmp30_ = innermost_src;
			vala_source_reference_get_begin (_tmp30_, &_tmp31_);
			_tmp32_ = _tmp31_;
			_tmp20_ = _tmp29_.column > _tmp32_.column;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			result = TRUE;
			return result;
		} else {
			gboolean _tmp33_ = FALSE;
			ValaSourceReference* _tmp34_;
			ValaSourceLocation _tmp35_ = {0};
			ValaSourceLocation _tmp36_;
			ValaSourceReference* _tmp37_;
			ValaSourceLocation _tmp38_ = {0};
			ValaSourceLocation _tmp39_;
			_tmp34_ = node_src;
			vala_source_reference_get_end (_tmp34_, &_tmp35_);
			_tmp36_ = _tmp35_;
			_tmp37_ = innermost_src;
			vala_source_reference_get_end (_tmp37_, &_tmp38_);
			_tmp39_ = _tmp38_;
			if (_tmp36_.line == _tmp39_.line) {
				ValaSourceReference* _tmp40_;
				ValaSourceLocation _tmp41_ = {0};
				ValaSourceLocation _tmp42_;
				ValaSourceReference* _tmp43_;
				ValaSourceLocation _tmp44_ = {0};
				ValaSourceLocation _tmp45_;
				_tmp40_ = node_src;
				vala_source_reference_get_end (_tmp40_, &_tmp41_);
				_tmp42_ = _tmp41_;
				_tmp43_ = innermost_src;
				vala_source_reference_get_end (_tmp43_, &_tmp44_);
				_tmp45_ = _tmp44_;
				_tmp33_ = _tmp42_.column < _tmp45_.column;
			} else {
				_tmp33_ = FALSE;
			}
			if (_tmp33_) {
				result = TRUE;
				return result;
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
ide_vala_locator_update_location (IdeValaLocator* self,
                                  ValaCodeNode* node,
                                  gboolean assign)
{
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaSourceLocation _tmp8_ = {0};
	ValaSourceLocation _tmp9_;
	ValaSourceReference* _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaSourceLocation _tmp12_ = {0};
	ValaSourceLocation _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSourceLocation _tmp16_ = {0};
	ValaSourceLocation _tmp17_;
	ValaSourceReference* _tmp18_;
	ValaSourceReference* _tmp19_;
	ValaSourceLocation _tmp20_ = {0};
	ValaSourceLocation _tmp21_;
	IdeValaLocatorLocation _tmp22_;
	IdeValaLocatorLocation _tmp23_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (!ide_vala_locator_location_inside (&self->priv->location, node)) {
		if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_SUBROUTINE)) {
			ValaBlock* body = NULL;
			ValaBlock* _tmp0_;
			ValaBlock* _tmp1_;
			ValaBlock* _tmp2_;
			_tmp0_ = vala_subroutine_get_body (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_SUBROUTINE, ValaSubroutine));
			_tmp1_ = _tmp0_;
			body = _tmp1_;
			_tmp2_ = body;
			if (ide_vala_locator_location_inside (&self->priv->location, (ValaCodeNode*) _tmp2_)) {
				ValaBlock* _tmp3_;
				_tmp3_ = body;
				vala_code_visitor_visit_block ((ValaCodeVisitor*) self, _tmp3_);
			}
		}
		result = FALSE;
		return result;
	}
	_tmp4_ = vala_code_node_get_type_name (node);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_code_node_get_source_reference (node);
	_tmp7_ = _tmp6_;
	vala_source_reference_get_begin (_tmp7_, &_tmp8_);
	_tmp9_ = _tmp8_;
	_tmp10_ = vala_code_node_get_source_reference (node);
	_tmp11_ = _tmp10_;
	vala_source_reference_get_begin (_tmp11_, &_tmp12_);
	_tmp13_ = _tmp12_;
	_tmp14_ = vala_code_node_get_source_reference (node);
	_tmp15_ = _tmp14_;
	vala_source_reference_get_end (_tmp15_, &_tmp16_);
	_tmp17_ = _tmp16_;
	_tmp18_ = vala_code_node_get_source_reference (node);
	_tmp19_ = _tmp18_;
	vala_source_reference_get_end (_tmp19_, &_tmp20_);
	_tmp21_ = _tmp20_;
	_tmp22_ = self->priv->location;
	_tmp23_ = self->priv->location;
	g_critical ("ide-vala-locator.vala:98: [%s] [%u.%u:%u.%u] matches location [%u.%u]", _tmp5_, (guint) _tmp9_.line, (guint) _tmp13_.column, (guint) _tmp17_.line, (guint) _tmp21_.column, _tmp22_.line, _tmp23_.column);
	if (ide_vala_locator_is_closer_to_location (self, node)) {
		g_critical ("ide-vala-locator.vala:101: Replacing innermost");
		if (assign) {
			ValaCodeNode* _tmp24_;
			_tmp24_ = _vala_code_node_ref0 (node);
			_vala_code_node_unref0 (self->priv->innermost);
			self->priv->innermost = _tmp24_;
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static void
ide_vala_locator_real_visit_assignment (ValaCodeVisitor* base,
                                        ValaAssignment* a)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (a != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) a, FALSE)) {
		vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_block (ValaCodeVisitor* base,
                                   ValaBlock* b)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (b != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) b, FALSE)) {
		vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_namespace (ValaCodeVisitor* base,
                                       ValaNamespace* ns)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (ns != NULL);
	ide_vala_locator_update_location (self, (ValaCodeNode*) ns, TRUE);
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_class (ValaCodeVisitor* base,
                                   ValaClass* cl)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (cl != NULL);
	ide_vala_locator_update_location (self, (ValaCodeNode*) cl, TRUE);
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_data_type (ValaCodeVisitor* base,
                                       ValaDataType* type)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (type != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) type, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) type, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_struct (ValaCodeVisitor* base,
                                    ValaStruct* st)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (st != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) st, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_interface (ValaCodeVisitor* base,
                                       ValaInterface* iface)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (iface != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) iface, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_method (ValaCodeVisitor* base,
                                    ValaMethod* m)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (m != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) m, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_method_call (ValaCodeVisitor* base,
                                         ValaMethodCall* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) expr, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_member_access (ValaCodeVisitor* base,
                                           ValaMemberAccess* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) expr, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                             ValaCreationMethod* m)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (m != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) m, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                        ValaObjectCreationExpression* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) expr, FALSE)) {
		vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_property (ValaCodeVisitor* base,
                                      ValaProperty* prop)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (prop != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                               ValaPropertyAccessor* acc)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (acc != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) acc, TRUE)) {
		vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_constructor (ValaCodeVisitor* base,
                                         ValaConstructor* c)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (c != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) c, FALSE)) {
		vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_destructor (ValaCodeVisitor* base,
                                        ValaDestructor* d)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (d != NULL);
	if (ide_vala_locator_update_location (self, (ValaCodeNode*) d, FALSE)) {
		vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
	}
}

static void
ide_vala_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                          ValaIfStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                              ValaSwitchStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                            ValaSwitchSection* section)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (section != NULL);
	vala_code_visitor_visit_block ((ValaCodeVisitor*) self, (ValaBlock*) section);
}

static void
ide_vala_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                             ValaWhileStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                          ValaDoStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                           ValaForStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                               ValaForeachStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                           ValaTryStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                          ValaCatchClause* clause)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (clause != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                            ValaLockStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                  ValaExpressionStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                   ValaDeclarationStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_local_variable (ValaCodeVisitor* base,
                                            ValaLocalVariable* variable)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (variable != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) variable, (ValaCodeVisitor*) self);
}

static void
ide_vala_locator_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                 ValaExpression* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION)) {
		ValaLambdaExpression* lambda_expr = NULL;
		ValaLambdaExpression* _tmp0_;
		ValaMethod* _tmp1_;
		ValaMethod* _tmp2_;
		lambda_expr = G_TYPE_CHECK_INSTANCE_CAST (expr, VALA_TYPE_LAMBDA_EXPRESSION, ValaLambdaExpression);
		_tmp0_ = lambda_expr;
		_tmp1_ = vala_lambda_expression_get_method (_tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_ != NULL) {
			ValaLambdaExpression* _tmp3_;
			ValaMethod* _tmp4_;
			ValaMethod* _tmp5_;
			_tmp3_ = lambda_expr;
			_tmp4_ = vala_lambda_expression_get_method (_tmp3_);
			_tmp5_ = _tmp4_;
			vala_code_visitor_visit_method ((ValaCodeVisitor*) self, _tmp5_);
		}
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL)) {
		{
			ValaList* _e_list = NULL;
			ValaList* _tmp6_;
			gint _e_size = 0;
			ValaList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _e_index = 0;
			_tmp6_ = vala_method_call_get_argument_list (G_TYPE_CHECK_INSTANCE_CAST (expr, VALA_TYPE_METHOD_CALL, ValaMethodCall));
			_e_list = _tmp6_;
			_tmp7_ = _e_list;
			_tmp8_ = vala_collection_get_size ((ValaCollection*) _tmp7_);
			_tmp9_ = _tmp8_;
			_e_size = _tmp9_;
			_e_index = -1;
			while (TRUE) {
				ValaExpression* e = NULL;
				ValaList* _tmp10_;
				gpointer _tmp11_;
				ValaExpression* _tmp12_;
				_e_index = _e_index + 1;
				if (!(_e_index < _e_size)) {
					break;
				}
				_tmp10_ = _e_list;
				_tmp11_ = vala_list_get (_tmp10_, _e_index);
				e = (ValaExpression*) _tmp11_;
				_tmp12_ = e;
				vala_code_visitor_visit_expression ((ValaCodeVisitor*) self, _tmp12_);
				_vala_code_node_unref0 (e);
			}
			_vala_iterable_unref0 (_e_list);
		}
	}
}

static void
ide_vala_locator_real_visit_expression (ValaCodeVisitor* base,
                                        ValaExpression* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION)) {
		ValaLambdaExpression* lambda_expr = NULL;
		ValaLambdaExpression* _tmp0_;
		ValaMethod* _tmp1_;
		ValaMethod* _tmp2_;
		lambda_expr = G_TYPE_CHECK_INSTANCE_CAST (expr, VALA_TYPE_LAMBDA_EXPRESSION, ValaLambdaExpression);
		_tmp0_ = lambda_expr;
		_tmp1_ = vala_lambda_expression_get_method (_tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_ != NULL) {
			ValaLambdaExpression* _tmp3_;
			ValaMethod* _tmp4_;
			ValaMethod* _tmp5_;
			_tmp3_ = lambda_expr;
			_tmp4_ = vala_lambda_expression_get_method (_tmp3_);
			_tmp5_ = _tmp4_;
			vala_code_visitor_visit_method ((ValaCodeVisitor*) self, _tmp5_);
		}
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_ASSIGNMENT)) {
		vala_code_node_accept_children ((ValaCodeNode*) G_TYPE_CHECK_INSTANCE_CAST (expr, VALA_TYPE_ASSIGNMENT, ValaAssignment), (ValaCodeVisitor*) self);
	}
}

IdeValaLocator*
ide_vala_locator_construct (GType object_type)
{
	IdeValaLocator* self = NULL;
	self = (IdeValaLocator*) vala_code_visitor_construct (object_type);
	return self;
}

IdeValaLocator*
ide_vala_locator_new (void)
{
	return ide_vala_locator_construct (IDE_TYPE_VALA_LOCATOR);
}

static void
ide_vala_locator_location_init (IdeValaLocatorLocation *self,
                                guint line,
                                guint column)
{
	memset (self, 0, sizeof (IdeValaLocatorLocation));
	(*self).line = line;
	(*self).column = column;
}

static gboolean
ide_vala_locator_location_inside (IdeValaLocatorLocation *self,
                                  ValaCodeNode* node)
{
	ValaSourceReference* src = NULL;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceLocation src_begin = {0};
	ValaSourceReference* _tmp3_;
	ValaSourceLocation _tmp4_ = {0};
	ValaSourceLocation _tmp5_;
	ValaSourceLocation src_end = {0};
	ValaSourceReference* _tmp6_;
	ValaSourceLocation _tmp7_ = {0};
	ValaSourceLocation _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	ValaSourceLocation _tmp14_;
	gboolean result = FALSE;
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = vala_code_node_get_source_reference (node);
	_tmp1_ = _tmp0_;
	src = _tmp1_;
	_tmp2_ = src;
	if (_tmp2_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp3_ = src;
	vala_source_reference_get_begin (_tmp3_, &_tmp4_);
	_tmp5_ = _tmp4_;
	src_begin = _tmp5_;
	_tmp6_ = src;
	vala_source_reference_get_end (_tmp6_, &_tmp7_);
	_tmp8_ = _tmp7_;
	src_end = _tmp8_;
	_tmp9_ = vala_code_node_get_type_name (node);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_code_node_to_string (node);
	_tmp12_ = _tmp11_;
	g_critical ("ide-vala-locator.vala:39: [%s]: %s", _tmp10_, _tmp12_);
	_g_free0 (_tmp12_);
	_tmp14_ = src_begin;
	if ((*self).line > ((guint) _tmp14_.line)) {
		ValaSourceLocation _tmp15_;
		_tmp15_ = src_end;
		_tmp13_ = (*self).line < ((guint) _tmp15_.line);
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		result = TRUE;
		return result;
	} else {
		gboolean _tmp16_ = FALSE;
		ValaSourceLocation _tmp17_;
		_tmp17_ = src_begin;
		if ((*self).line == ((guint) _tmp17_.line)) {
			ValaSourceLocation _tmp18_;
			_tmp18_ = src_end;
			_tmp16_ = (*self).line == ((guint) _tmp18_.line);
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			gboolean _tmp19_ = FALSE;
			ValaSourceLocation _tmp20_;
			_tmp20_ = src_begin;
			if ((*self).column >= ((guint) _tmp20_.column)) {
				ValaSourceLocation _tmp21_;
				_tmp21_ = src_end;
				_tmp19_ = (*self).column <= ((guint) _tmp21_.column);
			} else {
				_tmp19_ = FALSE;
			}
			result = _tmp19_;
			return result;
		} else {
			ValaSourceLocation _tmp22_;
			_tmp22_ = src_begin;
			if ((*self).line == ((guint) _tmp22_.line)) {
				ValaSourceLocation _tmp23_;
				_tmp23_ = src_begin;
				result = (*self).column >= ((guint) _tmp23_.column);
				return result;
			} else {
				ValaSourceLocation _tmp24_;
				_tmp24_ = src_end;
				if ((*self).line == ((guint) _tmp24_.line)) {
					ValaSourceLocation _tmp25_;
					_tmp25_ = src_end;
					result = (*self).column <= ((guint) _tmp25_.column);
					return result;
				} else {
					result = FALSE;
					return result;
				}
			}
		}
	}
}

static IdeValaLocatorLocation*
ide_vala_locator_location_dup (const IdeValaLocatorLocation* self)
{
	IdeValaLocatorLocation* dup;
	dup = g_new0 (IdeValaLocatorLocation, 1);
	memcpy (dup, self, sizeof (IdeValaLocatorLocation));
	return dup;
}

static void
ide_vala_locator_location_free (IdeValaLocatorLocation* self)
{
	g_free (self);
}

static GType
ide_vala_locator_location_get_type (void)
{
	static volatile gsize ide_vala_locator_location_type_id__volatile = 0;
	if (g_once_init_enter (&ide_vala_locator_location_type_id__volatile)) {
		GType ide_vala_locator_location_type_id;
		ide_vala_locator_location_type_id = g_boxed_type_register_static ("IdeValaLocatorLocation", (GBoxedCopyFunc) ide_vala_locator_location_dup, (GBoxedFreeFunc) ide_vala_locator_location_free);
		g_once_init_leave (&ide_vala_locator_location_type_id__volatile, ide_vala_locator_location_type_id);
	}
	return ide_vala_locator_location_type_id__volatile;
}

static void
ide_vala_locator_class_init (IdeValaLocatorClass * klass,
                             gpointer klass_data)
{
	ide_vala_locator_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = ide_vala_locator_finalize;
	g_type_class_adjust_private_offset (klass, &IdeValaLocator_private_offset);
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor*, ValaAssignment*)) ide_vala_locator_real_visit_assignment;
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor*, ValaBlock*)) ide_vala_locator_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor*, ValaNamespace*)) ide_vala_locator_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor*, ValaClass*)) ide_vala_locator_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor*, ValaDataType*)) ide_vala_locator_real_visit_data_type;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor*, ValaStruct*)) ide_vala_locator_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor*, ValaInterface*)) ide_vala_locator_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor*, ValaMethod*)) ide_vala_locator_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor*, ValaMethodCall*)) ide_vala_locator_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor*, ValaMemberAccess*)) ide_vala_locator_real_visit_member_access;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor*, ValaCreationMethod*)) ide_vala_locator_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor*, ValaObjectCreationExpression*)) ide_vala_locator_real_visit_object_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor*, ValaProperty*)) ide_vala_locator_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor*, ValaPropertyAccessor*)) ide_vala_locator_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor*, ValaConstructor*)) ide_vala_locator_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor*, ValaDestructor*)) ide_vala_locator_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor*, ValaIfStatement*)) ide_vala_locator_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor*, ValaSwitchStatement*)) ide_vala_locator_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor*, ValaSwitchSection*)) ide_vala_locator_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor*, ValaWhileStatement*)) ide_vala_locator_real_visit_while_statement;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor*, ValaDoStatement*)) ide_vala_locator_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor*, ValaForStatement*)) ide_vala_locator_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor*, ValaForeachStatement*)) ide_vala_locator_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor*, ValaTryStatement*)) ide_vala_locator_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor*, ValaCatchClause*)) ide_vala_locator_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor*, ValaLockStatement*)) ide_vala_locator_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor*, ValaExpressionStatement*)) ide_vala_locator_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor*, ValaDeclarationStatement*)) ide_vala_locator_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor*, ValaLocalVariable*)) ide_vala_locator_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_end_full_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) ide_vala_locator_real_visit_end_full_expression;
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) ide_vala_locator_real_visit_expression;
}

static void
ide_vala_locator_instance_init (IdeValaLocator * self,
                                gpointer klass)
{
	self->priv = ide_vala_locator_get_instance_private (self);
}

static void
ide_vala_locator_finalize (ValaCodeVisitor * obj)
{
	IdeValaLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IDE_TYPE_VALA_LOCATOR, IdeValaLocator);
	_vala_code_node_unref0 (self->priv->innermost);
	VALA_CODE_VISITOR_CLASS (ide_vala_locator_parent_class)->finalize (obj);
}

GType
ide_vala_locator_get_type (void)
{
	static volatile gsize ide_vala_locator_type_id__volatile = 0;
	if (g_once_init_enter (&ide_vala_locator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IdeValaLocatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ide_vala_locator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdeValaLocator), 0, (GInstanceInitFunc) ide_vala_locator_instance_init, NULL };
		GType ide_vala_locator_type_id;
		ide_vala_locator_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "IdeValaLocator", &g_define_type_info, 0);
		IdeValaLocator_private_offset = g_type_add_instance_private (ide_vala_locator_type_id, sizeof (IdeValaLocatorPrivate));
		g_once_init_leave (&ide_vala_locator_type_id__volatile, ide_vala_locator_type_id);
	}
	return ide_vala_locator_type_id__volatile;
}

